source: installer/opengnsys_update.sh @ 978e186

918-git-images-111dconfigfileconfigure-oglivegit-imageslgromero-new-oglivemainmaint-cronmount-efivarfsmultivmmultivm-ogboot-installerogClonningEngineogboot-installer-jenkinsoglive-ipv6test-python-scriptsticket-301ticket-50ticket-50-oldticket-577ticket-585ticket-611ticket-612ticket-693ticket-700ubu24tplunification2use-local-agent-oglivevarios-instalacionwebconsole3
Last change on this file since 978e186 was e6574b0, checked in by ramon <ramongomez@…>, 9 years ago

#730: Revisión correcta de ogLive 1.1.0-rc3.

git-svn-id: https://opengnsys.es/svn/branches/version1.1@4934 a21b9725-9963-47de-94b9-378ad31fedc9

  • Property mode set to 100755
File size: 33.4 KB
Line 
1#!/bin/bash
2#/**
3#@file    opengnsys_update.sh
4#@brief   Script actualización de OpenGnsys
5#@version 0.9 - basado en opengnsys_installer.sh
6#@author  Ramón Gómez - ETSII Univ. Sevilla
7#@date    2010/01/27
8#@version 1.0 - adaptación a OpenGnSys 1.0
9#@author  Ramón Gómez - ETSII Univ. Sevilla
10#@date    2011/03/02
11#@version 1.0.1 - control de auto actualización del script
12#@author  Ramón Gómez - ETSII Univ. Sevilla
13#@date    2011/05/17
14#@version 1.0.2a - obtiene valor de dirección IP por defecto
15#@author  Ramón Gómez - ETSII Univ. Sevilla
16#@date    2012/01/18
17#@version 1.0.3 - Compatibilidad con Debian y auto configuración de acceso a BD.
18#@author  Ramón Gómez - ETSII Univ. Sevilla
19#@date    2012/03/12
20#@version 1.0.4 - Detector de distribución y compatibilidad con CentOS.
21#@author  Ramón Gómez - ETSII Univ. Sevilla
22#@date    2012/05/04
23#@version 1.0.5 - Actualizar BD en la misma versión, compatibilidad con Fedora (systemd) y configuración de Rsync.
24#@author  Ramón Gómez - ETSII Univ. Sevilla
25#@date    2014/04/03
26#@version 1.0.6 - Redefinir URLs de ficheros de configuración usando HTTPS.
27#@author  Ramón Gómez - ETSII Univ. Sevilla
28#@date    2015/03/12
29#@version 1.1.0 - Instalación de API REST y configuración de zona horaria.
30#@author  Ramón Gómez - ETSII Univ. Sevilla
31#@date    2015/11/09
32#*/
33
34
35####  AVISO: NO EDITAR variables de configuración.
36####  WARNING: DO NOT EDIT configuration variables.
37INSTALL_TARGET=/opt/opengnsys           # Directorio de instalación
38OPENGNSYS_CLIENTUSER="opengnsys"        # Usuario Samba
39
40
41# Sólo ejecutable por usuario root
42if [ "$(whoami)" != 'root' ]; then
43        echo "ERROR: this program must run under root privileges!!"
44        exit 1
45fi
46# Error si OpenGnsys no está instalado (no existe el directorio del proyecto)
47if [ ! -d $INSTALL_TARGET ]; then
48        echo "ERROR: OpenGnsys is not installed, cannot update!!"
49        exit 1
50fi
51# Cargar configuración de acceso a la base de datos.
52if [ -r $INSTALL_TARGET/etc/ogAdmServer.cfg ]; then
53        source $INSTALL_TARGET/etc/ogAdmServer.cfg
54elif [ -r $INSTALL_TARGET/etc/ogAdmAgent.cfg ]; then
55        source $INSTALL_TARGET/etc/ogAdmAgent.cfg
56fi
57OPENGNSYS_DATABASE=${OPENGNSYS_DATABASE:-"$CATALOG"}            # Base de datos
58OPENGNSYS_DBUSER=${OPENGNSYS_DBUSER:-"$USUARIO"}                # Usuario de acceso
59OPENGNSYS_DBPASSWORD=${OPENGNSYS_DBPASSWORD:-"$PASSWORD"}       # Clave del usuario
60if [ -z "$OPENGNSYS_DATABASE" -o -z "$OPENGNSYS_DBUSER" -o -z "$OPENGNSYS_DBPASSWORD" ]; then
61        echo "ERROR: set OPENGNSYS_DATABASE, OPENGNSYS_DBUSER and OPENGNSYS_DBPASSWORD"
62        echo "       variables, and run this script again."
63fi
64
65# Comprobar si se ha descargado el paquete comprimido (USESVN=0) o sólo el instalador (USESVN=1).
66PROGRAMDIR=$(readlink -e $(dirname "$0"))
67PROGRAMNAME=$(basename "$0")
68OPENGNSYS_SERVER="www.opengnsys.es"
69if [ -d "$PROGRAMDIR/../installer" ]; then
70        USESVN=0
71else
72        USESVN=1
73fi
74SVN_URL="http://$OPENGNSYS_SERVER/svn/branches/version1.1/"
75
76WORKDIR=/tmp/opengnsys_update
77mkdir -p $WORKDIR
78
79# Registro de incidencias.
80OGLOGFILE=$INSTALL_TARGET/log/${PROGRAMNAME%.sh}.log
81LOG_FILE=/tmp/$(basename $OGLOGFILE)
82
83
84
85#####################################################################
86####### Algunas funciones útiles de propósito general:
87#####################################################################
88
89# Generar variables de configuración del actualizador
90# Variables globales:
91# - OSDISTRIB - distribución Linux
92# - DEPENDENCIES - array de dependencias que deben estar instaladas
93# - UPDATEPKGLIST, INSTALLPKGS, CHECKPKG - comandos para gestión de paquetes
94# - APACHECFGDIR, APACHESERV, DHCPSERV, INETDCFGDIR - configuración y servicios
95function autoConfigure()
96{
97local i
98
99# Detectar sistema operativo del servidor (compatible con fichero os-release y con LSB).
100if [ -f /etc/os-release ]; then
101        source /etc/os-release
102        OSDISTRIB="$ID"
103        OSVERSION="$VERSION_ID"
104else
105        OSDISTRIB=$(lsb_release -is 2>/dev/null)
106        OSVERSION=$(lsb_release -rs 2>/dev/null)
107fi
108# Convertir distribución a minúsculas y obtener solo el 1er número de versión.
109OSDISTRIB="${OSDISTRIB,,}"
110OSVERSION="${OSVERSION%%.*}"
111
112# Configuración según la distribución de Linux.
113case "$OSDISTRIB" in
114        ubuntu|debian|linuxmint)
115                DEPENDENCIES=( php5-ldap xinetd rsync btrfs-tools procps arp-scan realpath php5-curl gettext )
116                UPDATEPKGLIST="apt-get update"
117                INSTALLPKGS="apt-get -y install --force-yes"
118                CHECKPKG="dpkg -s \$package 2>/dev/null | grep -q \"Status: install ok\""
119                if which service &>/dev/null; then
120                        STARTSERVICE="eval service \$service restart"
121                        STOPSERVICE="eval service \$service stop"
122                else
123                        STARTSERVICE="eval /etc/init.d/\$service restart"
124                        STOPSERVICE="eval /etc/init.d/\$service stop"
125                fi
126                ENABLESERVICE="eval update-rc.d \$service defaults"
127                APACHEUSER="www-data"
128                APACHEGROUP="www-data"
129                INETDCFGDIR=/etc/xinetd.d
130                ;;
131        fedora|centos)
132                DEPENDENCIES=( php-ldap xinetd rsync btrfs-progs procps-ng arp-scan gettext )
133                # En CentOS 7 instalar arp-scan de CentOS 6.
134                [ "$OSDISTRIB$OSVERSION" == "centos7" ] && DEPENDENCIES=( ${DEPENDENCIES[*]/arp-scan/http://dag.wieers.com/redhat/el6/en/$(arch)/dag/RPMS/arp-scan-1.9-1.el6.rf.$(arch).rpm} )
135                INSTALLPKGS="yum install -y"
136                CHECKPKG="rpm -q --quiet \$package"
137                if which systemctl &>/dev/null; then
138                        STARTSERVICE="eval systemctl start \$service.service"
139                        STOPSERVICE="eval systemctl stop \$service.service"
140                        ENABLESERVICE="eval systemctl enable \$service.service"
141                else
142                        STARTSERVICE="eval service \$service start"
143                        STOPSERVICE="eval service \$service stop"
144                        ENABLESERVICE="eval chkconfig \$service on"
145                fi
146                APACHEUSER="apache"
147                APACHEGROUP="apache"
148                INETDCFGDIR=/etc/xinetd.d
149                ;;
150        *)      # Otras distribuciones.
151                ;;
152esac
153for i in apache2 httpd; do
154        [ -f /etc/$i ] && APACHECFGDIR="/etc/$i"
155        [ -f /etc/init.d/$i ] && APACHESERV="/etc/init.d/$i"
156done
157for i in dhcpd dhcpd3-server isc-dhcp-server; do
158        [ -f /etc/init.d/$i ] && DHCPSERV="/etc/init.d/$i"
159done
160}
161
162
163# Comprobar auto-actualización.
164function checkAutoUpdate()
165{
166        local update=0
167
168        # Actaulizar el script si ha cambiado o no existe el original.
169        if [ $USESVN -eq 1 ]; then
170                svn export $SVN_URL/installer/$PROGRAMNAME
171                if ! diff -q $PROGRAMNAME $INSTALL_TARGET/lib/$PROGRAMNAME 2>/dev/null || ! test -f $INSTALL_TARGET/lib/$PROGRAMNAME; then
172                        mv $PROGRAMNAME $INSTALL_TARGET/lib
173                        update=1
174                else
175                        rm -f $PROGRAMNAME
176                fi
177        else
178                if ! diff -q $PROGRAMDIR/$PROGRAMNAME $INSTALL_TARGET/lib/$PROGRAMNAME 2>/dev/null || ! test -f $INSTALL_TARGET/lib/$PROGRAMNAME; then
179                        cp -a $PROGRAMDIR/$PROGRAMNAME $INSTALL_TARGET/lib
180                        update=1
181                fi
182        fi
183
184        return $update
185}
186
187
188function getDateTime()
189{
190        date "+%Y%m%d-%H%M%S"
191}
192
193# Escribe a fichero y muestra por pantalla
194function echoAndLog()
195{
196        echo $1
197        DATETIME=`getDateTime`
198        echo "$DATETIME;$SSH_CLIENT;$1" >> $LOG_FILE
199}
200
201function errorAndLog()
202{
203        echo "ERROR: $1"
204        DATETIME=`getDateTime`
205        echo "$DATETIME;$SSH_CLIENT;ERROR: $1" >> $LOG_FILE
206}
207
208# Escribe a fichero y muestra mensaje de aviso
209function warningAndLog()
210{
211        local DATETIME=`getDateTime`
212        echo "Warning: $1"
213        echo "$DATETIME;$SSH_CLIENT;Warning: $1" >> $LOG_FILE
214}
215
216
217#####################################################################
218####### Funciones de copia de seguridad y restauración de ficheros
219#####################################################################
220
221# Hace un backup del fichero pasado por parámetro
222# deja un -last y uno para el día
223function backupFile()
224{
225        if [ $# -ne 1 ]; then
226                errorAndLog "${FUNCNAME}(): invalid number of parameters"
227                exit 1
228        fi
229
230        local fichero=$1
231        local fecha=`date +%Y%m%d`
232
233        if [ ! -f $fichero ]; then
234                warningAndLog "${FUNCNAME}(): file $fichero doesn't exists"
235                return 1
236        fi
237
238        echoAndLog "${FUNCNAME}(): Making $fichero back-up"
239
240        # realiza una copia de la última configuración como last
241        cp -a $fichero "${fichero}-LAST"
242
243        # si para el día no hay backup lo hace, sino no
244        if [ ! -f "${fichero}-${fecha}" ]; then
245                cp -a $fichero "${fichero}-${fecha}"
246        fi
247}
248
249# Restaura un fichero desde su copia de seguridad
250function restoreFile()
251{
252        if [ $# -ne 1 ]; then
253                errorAndLog "${FUNCNAME}(): invalid number of parameters"
254                exit 1
255        fi
256
257        local fichero=$1
258
259        echoAndLog "${FUNCNAME}(): restoring file $fichero"
260        if [ -f "${fichero}-LAST" ]; then
261                cp -a "$fichero-LAST" "$fichero"
262        fi
263}
264
265
266#####################################################################
267####### Funciones de acceso a base de datos
268#####################################################################
269
270# Actualizar la base datos
271function importSqlFile()
272{
273        if [ $# -ne 4 ]; then
274                errorAndLog "${FNCNAME}(): invalid number of parameters"
275                exit 1
276        fi
277
278        local dbuser="$1"
279        local dbpassword="$2"
280        local database="$3"
281        local sqlfile="$4"
282        local tmpfile=$(mktemp)
283        local mycnf=/tmp/.my.cnf.$$
284        local status
285        local APIKEY=$(php -r 'echo md5(uniqid(rand(), true));')
286        REPOKEY=$(php -r 'echo md5(uniqid(rand(), true));')
287
288        if [ ! -r $sqlfile ]; then
289                errorAndLog "${FUNCNAME}(): Unable to read $sqlfile!!"
290                return 1
291        fi
292
293        echoAndLog "${FUNCNAME}(): importing SQL file to ${database}..."
294        chmod 600 $tmpfile
295        sed -e "s/SERVERIP/$SERVERIP/g" -e "s/DBUSER/$OPENGNSYS_DB_USER/g" \
296            -e "s/DBPASSWORD/$OPENGNSYS_DB_PASSWD/g" \
297            -e "s/APIKEY/$APIKEY/g" -e "s/REPOKEY/$REPOKEY/g" $sqlfile > $tmpfile
298        # Componer fichero con credenciales de conexión. 
299        touch $mycnf
300        chmod 600 $mycnf
301        cat << EOT > $mycnf
302[client]
303user=$dbuser
304password=$dbpassword
305EOT
306        # Ejecutar actualización y borrar fichero de credenciales.
307        mysql --defaults-extra-file=$mycnf --default-character-set=utf8 -D "$database" < $tmpfile
308        status=$?
309        rm -f $mycnf $tmpfile
310        if [ $status -ne 0 ]; then
311                errorAndLog "${FUNCNAME}(): error importing $sqlfile in database $database"
312                return 1
313        fi
314        echoAndLog "${FUNCNAME}(): file imported to database $database"
315        return 0
316}
317
318
319#####################################################################
320####### Funciones de instalación de paquetes
321#####################################################################
322
323# Instalar las deependencias necesarias para el actualizador.
324function installDependencies()
325{
326        local package
327
328        if [ $# = 0 ]; then
329                echoAndLog "${FUNCNAME}(): no deps needed."
330        else
331                while [ $# -gt 0 ]; do
332                        package="$1"
333                        eval $CHECKPKG || INSTALLDEPS="$INSTALLDEPS $1"
334                        shift
335                done
336                if [ -n "$INSTALLDEPS" ]; then
337                        $UPDATEPKGLIST
338                        $INSTALLPKGS $INSTALLDEPS
339                        if [ $? -ne 0 ]; then
340                                errorAndLog "${FUNCNAME}(): cannot install some dependencies: $INSTALLDEPS."
341                                return 1
342                        fi
343                fi
344        fi
345}
346
347
348#####################################################################
349####### Funciones para el manejo de Subversion
350#####################################################################
351
352function svnExportCode()
353{
354        if [ $# -ne 1 ]; then
355                errorAndLog "${FUNCNAME}(): invalid number of parameters"
356                exit 1
357        fi
358
359        local url="$1"
360
361        echoAndLog "${FUNCNAME}(): downloading subversion code..."
362
363        svn checkout "${url}" opengnsys
364        if [ $? -ne 0 ]; then
365                errorAndLog "${FUNCNAME}(): error getting code from ${url}, verify your user and password"
366                return 1
367        fi
368        echoAndLog "${FUNCNAME}(): subversion code downloaded"
369        return 0
370}
371
372
373############################################################
374###  Detectar red
375############################################################
376
377# Comprobar si existe conexión.
378function checkNetworkConnection()
379{
380        OPENGNSYS_SERVER=${OPENGNSYS_SERVER:-"www.opengnsys.es"}
381        wget --spider -q $OPENGNSYS_SERVER
382}
383
384# Obtener los parámetros de red del servidor.
385function getNetworkSettings()
386{
387        # Variables globales definidas:
388        # - SERVERIP:   IP local de la interfaz por defecto.
389
390        local DEVICES
391        local dev
392
393        echoAndLog "${FUNCNAME}(): Detecting network parameters."
394        SERVERIP="$ServidorAdm"
395        DEVICES="$(ip -o link show up | awk '!/loopback/ {sub(/:.*/,"",$2); print $2}')"
396        for dev in $DEVICES; do
397                [ -z "$SERVERIP" ] && SERVERIP=$(ip -o addr show dev $dev | awk '$3~/inet$/ {sub (/\/.*/, ""); print ($4)}')
398        done
399}
400
401
402#####################################################################
403####### Funciones específicas de la instalación de Opengnsys
404#####################################################################
405
406# Actualizar cliente OpenGnsys.
407function updateClientFiles()
408{
409        # Actualizar ficheros del cliente.
410        echoAndLog "${FUNCNAME}(): Updating OpenGnsys Client files."
411        rsync --exclude .svn -irplt $WORKDIR/opengnsys/client/shared/* $INSTALL_TARGET/client
412        if [ $? -ne 0 ]; then
413                errorAndLog "${FUNCNAME}(): error while updating client structure"
414                exit 1
415        fi
416        find $INSTALL_TARGET/client -name .svn -type d -exec rm -fr {} \; 2>/dev/null
417
418        # Actualizar librerías del motor de clonación.
419        echoAndLog "${FUNCNAME}(): Updating OpenGnsys Cloning Engine files."
420        rsync --exclude .svn -irplt $WORKDIR/opengnsys/client/engine/*.lib* $INSTALL_TARGET/client/lib/engine/bin
421        if [ $? -ne 0 ]; then
422                errorAndLog "${FUNCNAME}(): error while updating engine files"
423                exit 1
424        fi
425        # Actualizar fichero de configuración del motor de clonación.
426        if ! grep -q "^TZ" $INSTALL_TARGET/client/etc/engine.cfg; then
427                TZ=$(timedatectl status | awk -F"[:()]" '/Time.*zone/ {print $2}')
428                cat << EOT >> $INSTALL_TARGET/client/etc/engine.cfg
429# OpenGnsys Server timezone.
430TZ="${TZ// /}"
431EOT
432        fi
433
434        echoAndLog "${FUNCNAME}(): client files update success."
435}
436
437# Configurar HTTPS y exportar usuario y grupo del servicio Apache.
438function apacheConfiguration ()
439{
440        # Activar HTTPS (solo actualizando desde versiones anteriores a 1.0.2) y
441        #    activar módulo Rewrite (solo actualizaciones desde 1.0.x a 1.1.x).
442        if [ -e $APACHECFGDIR/sites-available/opengnsys.conf ]; then
443                echoAndLog "${FUNCNAME}(): Configuring Apache modules."
444                mv $APACHECFGDIR/sites-available/opengnsys.conf $APACHECFGDIR/sites-available/opengnsys
445                a2ensite default-ssl
446                a2enmod ssl
447                a2enmod rewrite
448                a2dissite opengnsys.conf
449                a2ensite opengnsys
450        elif [ -e $APACHECFGDIR/conf.modules.d ]; then
451                echoAndLog "${FUNCNAME}(): Configuring Apache modules."
452                sed -i '/rewrite/s/^#//' $APACHECFGDIR/*.conf
453        fi
454
455        # Actualizar configuración para acceso a API REST
456        #    (solo actualizaciones de 1.0.x a 1.1.x).
457        for config in $APACHECFGDIR/{,sites-available/}opengnsys.conf ]; do
458                if [ -e $config ] && ! grep -q "/rest" $config; then
459                        cat << EOT >> $config
460<Directory $INSTALL_TARGET/www/rest>
461        RewriteEngine On
462        RewriteBase /opengnsys/rest/
463        RewriteCond %{REQUEST_FILENAME} !-f
464        RewriteRule ^ index.php [QSA,L]
465</Directory>
466EOT
467                fi
468        done
469
470        # Reiniciar Apache.
471        $APACHESERV restart
472
473        # Variables de ejecución de Apache.
474        # - APACHE_RUN_USER
475        # - APACHE_RUN_GROUP
476        if [ -f $APACHECFGDIR/envvars ]; then
477                source $APACHECFGDIR/envvars
478        fi
479        APACHE_RUN_USER=${APACHE_RUN_USER:-"$APACHEUSER"}
480        APACHE_RUN_GROUP=${APACHE_RUN_GROUP:-"$APACHEGROUP"}
481}
482
483# Configurar servicio Rsync.
484function rsyncConfigure()
485{
486        local service
487
488        # Configurar acceso a Rsync.
489        if [ ! -f /etc/rsyncd.conf ]; then
490                echoAndLog "${FUNCNAME}(): Configuring Rsync service."
491                NEWFILES="$NEWFILES /etc/rsyncd.conf"
492                sed -e "s/CLIENTUSER/$OPENGNSYS_CLIENTUSER/g" \
493                    $WORKDIR/opengnsys/repoman/etc/rsyncd.conf.tmpl > /etc/rsyncd.conf
494                # Habilitar Rsync.
495                if [ -f /etc/default/rsync ]; then
496                        perl -pi -e 's/RSYNC_ENABLE=.*/RSYNC_ENABLE=inetd/' /etc/default/rsync
497                fi
498                if [ -f $INETDCFGDIR/rsync ]; then
499                        perl -pi -e 's/disable.*/disable = no/' $INETDCFGDIR/rsync
500                else
501                        cat << EOT > $INETDCFGDIR/rsync
502service rsync
503{
504        disable = no
505        socket_type = stream
506        wait = no
507        user = root
508        server = $(which rsync)
509        server_args = --daemon
510        log_on_failure += USERID
511        flags = IPv6
512}
513EOT
514                fi
515                # Activar e iniciar Rsync.
516                service="rsync"  $ENABLESERVICE
517                service="xinetd"
518                $ENABLESERVICE; $STARTSERVICE
519        fi
520}
521
522# Copiar ficheros del OpenGnsys Web Console.
523function updateWebFiles()
524{
525        local ERRCODE COMPATDIR f
526
527        echoAndLog "${FUNCNAME}(): Updating web files..."
528
529        # Copiar los ficheros nuevos conservando el archivo de configuración de acceso.
530        backupFile $INSTALL_TARGET/www/controlacceso.php
531        mv $INSTALL_TARGET/www $INSTALL_TARGET/WebConsole
532        rsync --exclude .svn -irplt $WORKDIR/opengnsys/admin/WebConsole $INSTALL_TARGET
533        ERRCODE=$?
534        mv $INSTALL_TARGET/WebConsole $INSTALL_TARGET/www
535        unzip -o $WORKDIR/opengnsys/admin/xajax_0.5_standard.zip -d $INSTALL_TARGET/www/xajax
536        unzip -o $WORKDIR/opengnsys/admin/slim-2.6.1.zip -d $INSTALL_TARGET/www/rest
537        if [ $ERRCODE != 0 ]; then
538                errorAndLog "${FUNCNAME}(): Error updating web files."
539                exit 1
540        fi
541        restoreFile $INSTALL_TARGET/www/controlacceso.php
542
543        # Cambiar acceso a protocolo HTTPS.
544        if grep -q "http://" $INSTALL_TARGET/www/controlacceso.php 2>/dev/null; then
545                echoAndLog "${FUNCNAME}(): updating web access file"
546                perl -pi -e 's!http://!https://!g' $INSTALL_TARGET/www/controlacceso.php
547                NEWFILES="$NEWFILES $INSTALL_TARGET/www/controlacceso.php"
548        fi
549
550        # Compatibilidad con dispositivos móviles.
551        COMPATDIR="$INSTALL_TARGET/www/principal"
552        for f in acciones administracion aula aulas hardwares imagenes menus repositorios softwares; do
553                sed 's/clickcontextualnodo/clicksupnodo/g' $COMPATDIR/$f.php > $COMPATDIR/$f.device.php
554        done
555        cp -a $COMPATDIR/imagenes.device.php $COMPATDIR/imagenes.device4.php
556
557        # Cambiar permisos para ficheros especiales.
558        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/images/{fotos,iconos}
559        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/tmp/
560        # Fichero de logs del agente OGAgent.
561        touch $INSTALL_TARGET/log/ogagent.log
562        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/log/ogagent.log
563
564        echoAndLog "${FUNCNAME}(): Web files updated successfully."
565}
566
567# Copiar carpeta de Interface
568function updateInterfaceAdm()
569{
570        local errcode=0
571
572        # Crear carpeta y copiar Interface
573        echoAndLog "${FUNCNAME}(): Copying Administration Interface Folder"
574        mv $INSTALL_TARGET/client/interfaceAdm $INSTALL_TARGET/client/Interface
575        rsync --exclude .svn -irplt $WORKDIR/opengnsys/admin/Interface $INSTALL_TARGET/client
576        errcoce=$?
577        mv $INSTALL_TARGET/client/Interface $INSTALL_TARGET/client/interfaceAdm
578        if [ $errcode -ne 0 ]; then
579                echoAndLog "${FUNCNAME}(): error while updating admin interface"
580                exit 1
581        fi
582        chmod -R +x $INSTALL_TARGET/client/interfaceAdm
583        chown $OPENGNSYS_CLIENTUSER:$OPENGNSYS_CLIENTUSER $INSTALL_TARGET/client/interfaceAdm/CambiarAcceso
584        chmod 700 $INSTALL_TARGET/client/interfaceAdm/CambiarAcceso
585        echoAndLog "${FUNCNAME}(): Admin interface updated successfully."
586}
587
588# Crear documentación Doxygen para la consola web.
589function makeDoxygenFiles()
590{
591        echoAndLog "${FUNCNAME}(): Making Doxygen web files..."
592        $WORKDIR/opengnsys/installer/ogGenerateDoc.sh \
593                        $WORKDIR/opengnsys/client/engine $INSTALL_TARGET/www
594        if [ ! -d "$INSTALL_TARGET/www/html" ]; then
595                errorAndLog "${FUNCNAME}(): unable to create Doxygen web files."
596                return 1
597        fi
598        rm -fr "$INSTALL_TARGET/www/api"
599        mv "$INSTALL_TARGET/www/html" "$INSTALL_TARGET/www/api"
600        rm -fr $INSTALL_TARGET/www/{man,perlmod,rtf}
601        chown -R $APACHE_RUN_USER:$APACHE_RUN_GROUP $INSTALL_TARGET/www/api
602        echoAndLog "${FUNCNAME}(): Doxygen web files created successfully."
603}
604
605
606# Crea la estructura base de la instalación de opengnsys
607function createDirs()
608{
609        # Crear estructura de directorios.
610        echoAndLog "${FUNCNAME}(): creating directory paths in ${INSTALL_TARGET}"
611        local dir
612
613        mkdir -p ${INSTALL_TARGET}/{bin,doc,etc,lib,sbin,www}
614        mkdir -p ${INSTALL_TARGET}/{client,images}
615        mkdir -p ${INSTALL_TARGET}/log/clients
616        ln -fs ${INSTALL_TARGET}/log /var/log/opengnsys
617        # Detectar directorio de instalación de TFTP.
618        if [ ! -L ${INSTALL_TARGET}/tftpboot ]; then
619                for dir in /var/lib/tftpboot /srv/tftp; do
620                        [ -d $dir ] && ln -fs $dir ${INSTALL_TARGET}/tftpboot
621                done
622        fi
623        mkdir -p ${INSTALL_TARGET}/tftpboot/menu.lst
624        if [ $? -ne 0 ]; then
625                errorAndLog "${FUNCNAME}(): error while creating dirs. Do you have write permissions?"
626                return 1
627        fi
628
629        # Crear usuario ficticio.
630        if id -u $OPENGNSYS_CLIENTUSER &>/dev/null; then
631                echoAndLog "${FUNCNAME}(): user \"$OPENGNSYS_CLIENTUSER\" is already created"
632        else
633                echoAndLog "${FUNCNAME}(): creating OpenGnsys user"
634                useradd $OPENGNSYS_CLIENTUSER 2>/dev/null
635                if [ $? -ne 0 ]; then
636                        errorAndLog "${FUNCNAME}(): error creating OpenGnsys user"
637                        return 1
638                fi
639        fi
640
641        # Establecer los permisos básicos.
642        echoAndLog "${FUNCNAME}(): setting directory permissions"
643        chmod -R 775 $INSTALL_TARGET/{log/clients,images,tftpboot/menu.lst}
644        mkdir -p $INSTALL_TARGET/tftpboot/menu.lst/examples
645        ! [ -f $INSTALL_TARGET/tftpboot/menu.lst/templates/00unknown ] && mv $INSTALL_TARGET/tftpboot/menu.lst/templates/* $INSTALL_TARGET/tftpboot/menu.lst/examples
646        chown -R :$OPENGNSYS_CLIENTUSER $INSTALL_TARGET/{log/clients,images,tftpboot/menu.lst}
647        if [ $? -ne 0 ]; then
648                errorAndLog "${FUNCNAME}(): error while setting permissions"
649                return 1
650        fi
651
652        # Mover el fichero de registro al directorio de logs.
653        echoAndLog "${FUNCNAME}(): moving update log file"
654        mv $LOG_FILE $OGLOGFILE && LOG_FILE=$OGLOGFILE
655        chmod 600 $LOG_FILE
656
657        echoAndLog "${FUNCNAME}(): directory paths created"
658        return 0
659}
660
661# Copia ficheros de configuración y ejecutables genéricos del servidor.
662function updateServerFiles()
663{
664        # No copiar ficheros del antiguo cliente Initrd
665        local SOURCES=( repoman/bin \
666                        server/bin \
667                        admin/Sources/Services/ogAdmServerAux \
668                        admin/Sources/Services/ogAdmRepoAux \
669                        server/tftpboot \
670                        installer/opengnsys_uninstall.sh \
671                        doc )
672        local TARGETS=( bin \
673                        bin \
674                        sbin/ogAdmServerAux \
675                        sbin/ogAdmRepoAux \
676                        tftpboot \
677                        lib/opengnsys_uninstall.sh \
678                        doc )
679
680        if [ ${#SOURCES[@]} != ${#TARGETS[@]} ]; then
681                errorAndLog "${FUNCNAME}(): inconsistent number of array items"
682                exit 1
683        fi
684
685        echoAndLog "${FUNCNAME}(): updating files in server directories"
686        pushd $WORKDIR/opengnsys >/dev/null
687        local i
688        for (( i = 0; i < ${#SOURCES[@]}; i++ )); do
689                if [ -d "$INSTALL_TARGET/${TARGETS[i]}" ]; then
690                        rsync --exclude .svn -irplt "${SOURCES[i]}" $(dirname $(readlink -e "$INSTALL_TARGET/${TARGETS[i]}"))
691                else
692                        rsync -irplt "${SOURCES[i]}" $(readlink -m "$INSTALL_TARGET/${TARGETS[i]}")
693                fi
694        done
695        popd >/dev/null
696        NEWFILES=""             # Ficheros de configuración que han cambiado de formato.
697        if grep -q 'pxelinux.0' /etc/dhcp*/dhcpd*.conf; then
698                echoAndLog "${FUNCNAME}(): updating DHCP files"
699                perl -pi -e 's/pxelinux.0/grldr/' /etc/dhcp*/dhcpd*.conf
700                $DHCPSERV restart
701                NEWFILES="/etc/dhcp*/dhcpd*.conf"
702        fi
703        if ! diff -q $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.init /etc/init.d/opengnsys 2>/dev/null; then
704                echoAndLog "${FUNCNAME}(): updating new init file"
705                backupFile /etc/init.d/opengnsys
706                cp -a $WORKDIR/opengnsys/admin/Sources/Services/opengnsys.init /etc/init.d/opengnsys
707                NEWFILES="$NEWFILES /etc/init.d/opengnsys"
708        fi
709        if egrep -q "(UrlMsg=.*msgbrowser.php)|(UrlMenu=http://)" $INSTALL_TARGET/client/etc/ogAdmClient.cfg 2>/dev/null; then
710                echoAndLog "${FUNCNAME}(): updating new client config file"
711                backupFile $INSTALL_TARGET/client/etc/ogAdmClient.cfg
712                perl -pi -e 's!UrlMsg=.*msgbrowser\.php!UrlMsg=http://localhost/cgi-bin/httpd-log\.sh!g; s!UrlMenu=http://!UrlMenu=https://!g' $INSTALL_TARGET/client/etc/ogAdmClient.cfg
713                NEWFILES="$NEWFILES $INSTALL_TARGET/client/etc/ogAdmClient.cfg"
714        fi
715
716        echoAndLog "${FUNCNAME}(): updating cron files"
717        [ ! -f /etc/cron.d/opengnsys ] && echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/opengnsys.cron ] && $INSTALL_TARGET/bin/opengnsys.cron" > /etc/cron.d/opengnsys
718        [ ! -f /etc/cron.d/torrentcreator ] && echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-creator ] && $INSTALL_TARGET/bin/torrent-creator" > /etc/cron.d/torrentcreator
719        [ ! -f /etc/cron.d/torrenttracker ] && echo "5 * * * *   root   [ -x $INSTALL_TARGET/bin/torrent-tracker ] && $INSTALL_TARGET/bin/torrent-tracker" > /etc/cron.d/torrenttracker
720        [ ! -f /etc/cron.d/imagedelete ] && echo "* * * * *   root   [ -x $INSTALL_TARGET/bin/deletepreimage ] && $INSTALL_TARGET/bin/deletepreimage" > /etc/cron.d/imagedelete
721        echoAndLog "${FUNCNAME}(): server files updated successfully."
722}
723
724####################################################################
725### Funciones de compilación de código fuente de servicios
726####################################################################
727
728# Mueve el fichero del nuevo servicio si es distinto al del directorio destino.
729function moveNewService()
730{
731        local service
732
733        # Recibe 2 parámetros: fichero origen y directorio destino.
734        [ $# == 2 ] || return 1
735        [ -f  $1 -a -d $2 ] || return 1
736
737        # Comparar los ficheros.
738        if ! diff -q $1 $2/$(basename $1) &>/dev/null; then
739                # Parar los servicios si fuese necesario.
740                [ -z "$NEWSERVICES" ] && service="opengnsys" $STOPSERVICE
741                # Nuevo servicio.
742                NEWSERVICES="$NEWSERVICES $(basename $1)"
743                # Mover el nuevo fichero de servicio
744                mv $1 $2
745        fi
746}
747
748
749# Recompilar y actualiza los serivicios y clientes.
750function compileServices()
751{
752        local hayErrores=0
753
754        # Compilar OpenGnsys Server
755        echoAndLog "${FUNCNAME}(): Recompiling OpenGnsys Admin Server"
756        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmServer
757        make && moveNewService ogAdmServer $INSTALL_TARGET/sbin
758        if [ $? -ne 0 ]; then
759                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Admin Server"
760                hayErrores=1
761        fi
762        popd
763        # Compilar OpenGnsys Repository Manager
764        echoAndLog "${FUNCNAME}(): Recompiling OpenGnsys Repository Manager"
765        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmRepo
766        make && moveNewService ogAdmRepo $INSTALL_TARGET/sbin
767        if [ $? -ne 0 ]; then
768                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Repository Manager"
769                hayErrores=1
770        fi
771        popd
772        # Actualizar o insertar clave de acceso REST en el fichero de configuración del repositorio.
773        grep -q '^ApiToken=' $INSTALL_TARGET/etc/ogAdmRepo.cfg && \
774                sed -i "s/^ApiToken=.*$/ApiToken=$REPOKEY/" $INSTALL_TARGET/etc/ogAdmRepo.cfg || \
775                sed -i "$ a\ApiToken=$REPOKEY/" $INSTALL_TARGET/etc/ogAdmRepo.cfg
776        # Compilar OpenGnsys Agent
777        echoAndLog "${FUNCNAME}(): Recompiling OpenGnsys Agent"
778        pushd $WORKDIR/opengnsys/admin/Sources/Services/ogAdmAgent
779        make && moveNewService ogAdmAgent $INSTALL_TARGET/sbin
780        if [ $? -ne 0 ]; then
781                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Agent"
782                hayErrores=1
783        fi
784        popd
785
786        # Compilar OpenGnsys Client
787        echoAndLog "${FUNCNAME}(): Recompiling OpenGnsys Client"
788        pushd $WORKDIR/opengnsys/admin/Sources/Clients/ogAdmClient
789        make && mv ogAdmClient $INSTALL_TARGET/client/bin
790        if [ $? -ne 0 ]; then
791                echoAndLog "${FUNCNAME}(): error while compiling OpenGnsys Client"
792                hayErrores=1
793        fi
794        popd
795
796        return $hayErrores
797}
798
799
800####################################################################
801### Funciones instalacion cliente OpenGnsys
802####################################################################
803
804# Actualizar cliente OpenGnsys
805function updateClient()
806{
807        local DOWNLOADURL="http://$OPENGNSYS_SERVER/downloads"
808        local FILENAME=ogLive-wily-4.2.0-35-generic-r4919.iso           # 1.1.0-rc3
809        local SOURCEFILE=$DOWNLOADURL/$FILENAME
810        local TARGETFILE=$INSTALL_TARGET/lib/$FILENAME
811        local SOURCELENGTH
812        local TARGETLENGTH
813        local OGINITRD=$INSTALL_TARGET/tftpboot/ogclient/oginitrd.img
814        local OGVMLINUZ=$INSTALL_TARGET/tftpboot/ogclient/ogvmlinuz
815        local SAMBAPASS
816        local KERNELVERSION
817
818        # Comprobar si debe actualizarse el cliente.
819        SOURCELENGTH=$(LANG=C wget --spider $SOURCEFILE 2>&1 | awk '/Length:/ {print $2}')
820        TARGETLENGTH=$(ls -l $TARGETFILE 2>/dev/null | awk '{print $5}')
821        [ -z $TARGETLENGTH ] && TARGETLENGTH=0
822        if [ "$SOURCELENGTH" != "$TARGETLENGTH" ]; then
823                echoAndLog "${FUNCNAME}(): Loading Client"
824                wget $DOWNLOADURL/$FILENAME -O $TARGETFILE
825                if [ ! -s $TARGETFILE ]; then
826                        errorAndLog "${FUNCNAME}(): Error loading OpenGnsys Client"
827                        return 1
828                fi
829                # Actaulizar la imagen ISO del ogclient.
830                echoAndLog "${FUNCNAME}(): Updatting ogclient files"
831                $INSTALL_TARGET/bin/installoglive $TARGETFILE
832               
833                # Obtiene versión del Kernel del cliente (con 2 decimales).
834                KERNELVERSION=$(file -bkr $OGVMLINUZ 2>/dev/null | \
835                                awk '/Linux/ { for (i=1; i<=NF; i++)
836                                                   if ($i~/version/) {
837                                                      v=$(i+1);
838                                                      printf ("%d",v);
839                                                      sub (/[0-9]*\./,"",v);
840                                                      printf (".%02d",v)
841                                             } }')
842                # Actaulizar la base de datos adaptada al Kernel del cliente.
843                OPENGNSYS_DBUPDATEFILE="$WORKDIR/opengnsys/admin/Database/$OPENGNSYS_DATABASE-$INSTVERSION-postinst.sql"
844                if [ -f $OPENGNSYS_DBUPDATEFILE ]; then
845                        perl -pi -e "s/KERNELVERSION/$KERNELVERSION/g" $OPENGNSYS_DBUPDATEFILE
846                        importSqlFile $OPENGNSYS_DBUSER $OPENGNSYS_DBPASSWORD $OPENGNSYS_DATABASE $OPENGNSYS_DBUPDATEFILE
847                fi
848
849                echoAndLog "${FUNCNAME}(): Client update successfully"
850        else
851                # Si no existe, crear el fichero de claves de Rsync.
852                if [ ! -f /etc/rsyncd.secrets ]; then
853                        echoAndLog "${FUNCNAME}(): Restoring client access key"
854                        SAMBAPASS=$(gzip -dc $OGINITRD | \
855                                    cpio -i --to-stdout scripts/ogfunctions 2>&1 | \
856                                    grep "^[    ].*OPTIONS=" | \
857                                    sed 's/\(.*\)pass=\(\w*\)\(.*\)/\2/')
858                        echo -ne "$SAMBAPASS\n$SAMBAPASS\n" | \
859                                        $INSTALL_TARGET/bin/setsmbpass
860                else
861                        echoAndLog "${FUNCNAME}(): Client is already updated"
862                fi
863        fi
864}
865
866# Comprobar permisos y ficheros.
867function checkFiles()
868{
869        # Comprobar permisos adecuados.
870        if [ -x $INSTALL_TARGET/bin/checkperms ]; then
871                echoAndLog "${FUNCNAME}(): Checking permissions."
872                OPENGNSYS_DIR="$INSTALL_TARGET" OPENGNSYS_USER="$OPENGNSYS_CLIENTUSER" APACHE_USER="$APACHE_RUN_USER" APACHE_GROUP="$APACHE_RUN_GROUP" $INSTALL_TARGET/bin/checkperms
873        fi
874
875        # Eliminamos el fichero de estado del tracker porque es incompatible entre los distintos paquetes
876        if [ -f /tmp/dstate ]; then
877                echoAndLog "${FUNCNAME}(): Delete unused files."
878                rm -f /tmp/dstate
879        fi
880}
881
882# Resumen de actualización.
883function updateSummary()
884{
885        # Actualizar fichero de versión y revisión.
886        local VERSIONFILE="$INSTALL_TARGET/doc/VERSION.txt"
887        local REVISION=$(LANG=C svn info $SVN_URL|awk '/Rev:/ {print "r"$4}')
888
889        [ -f $VERSIONFILE ] || echo "OpenGnsys" >$VERSIONFILE
890        perl -pi -e "s/($| r[0-9]*)/ $REVISION/" $VERSIONFILE
891
892        echo
893        echoAndLog "OpenGnsys Update Summary"
894        echo       "========================"
895        echoAndLog "Project version:                  $(cat $VERSIONFILE)"
896        echoAndLog "Update log file:                  $LOG_FILE"
897        if [ -n "$NEWFILES" ]; then
898                echoAndLog "Check new config files:           $(echo $NEWFILES)"
899        fi
900        if [ -n "$NEWSERVICES" ]; then
901                echoAndLog "New compiled services:            $(echo $NEWSERVICES)"
902                # Indicar si se debe reiniciar servicios manualmente o usando el Cron.
903                [ -f /etc/default/opengnsys ] && source /etc/default/opengnsys
904                if [ "$RUN_CRONJOB" == "no" ]; then
905                        echoAndLog "        WARNING: you must restart OpenGnsys services manually."
906                else
907                        echoAndLog "        New OpenGnsys services will be restarted by the cronjob."
908                fi
909        fi
910        echoAndLog "Warning: You must to clear web browser cache before loading OpenGnSys page."
911        echo
912}
913
914
915
916#####################################################################
917####### Proceso de actualización de OpenGnsys
918#####################################################################
919
920
921echoAndLog "OpenGnsys update begins at $(date)"
922
923pushd $WORKDIR
924
925# Comprobar si hay conexión y detectar parámetros de red por defecto.
926checkNetworkConnection
927if [ $? -ne 0 ]; then
928        errorAndLog "Error connecting to server. Causes:"
929        errorAndLog " - Network is unreachable, review devices parameters."
930        errorAndLog " - You are inside a private network, configure the proxy service."
931        errorAndLog " - Server is temporally down, try agian later."
932        exit 1
933fi
934getNetworkSettings
935
936# Comprobar auto-actualización del programa.
937if [ "$PROGRAMDIR" != "$INSTALL_TARGET/bin" ]; then
938        checkAutoUpdate
939        if [ $? -ne 0 ]; then
940                echoAndLog "OpenGnsys updater has been overwritten."
941                echoAndLog "Please, re-execute this script."
942                exit
943        fi
944fi
945
946# Detectar datos de auto-configuración del instalador.
947autoConfigure
948
949# Instalar dependencias.
950installDependencies ${DEPENDENCIES[*]}
951if [ $? -ne 0 ]; then
952        errorAndLog "Error: you may install all needed dependencies."
953        exit 1
954fi
955
956# Arbol de directorios de OpenGnsys.
957createDirs ${INSTALL_TARGET}
958if [ $? -ne 0 ]; then
959        errorAndLog "Error while creating directory paths!"
960        exit 1
961fi
962
963# Si es necesario, descarga el repositorio de código en directorio temporal
964if [ $USESVN -eq 1 ]; then
965        svnExportCode $SVN_URL
966        if [ $? -ne 0 ]; then
967                errorAndLog "Error while getting code from svn"
968                exit 1
969        fi
970else
971        ln -fs "$(dirname $PROGRAMDIR)" opengnsys
972fi
973
974# Si existe fichero de actualización de la base de datos; aplicar cambios.
975INSTVERSION=$(awk '{print $2}' $INSTALL_TARGET/doc/VERSION.txt)
976REPOVERSION=$(awk '{print $2}' $WORKDIR/opengnsys/doc/VERSION.txt)
977if [ "$INSTVERSION" == "$REPOVERSION" ]; then
978        OPENGNSYS_DBUPDATEFILE="$WORKDIR/opengnsys/admin/Database/$OPENGNSYS_DATABASE-$INSTVERSION.sql"
979else
980        OPENGNSYS_DBUPDATEFILE="$WORKDIR/opengnsys/admin/Database/$OPENGNSYS_DATABASE-$INSTVERSION-$REPOVERSION.sql"
981fi
982if [ -f $OPENGNSYS_DBUPDATEFILE ]; then
983        echoAndLog "Updating tables from file: $(basename $OPENGNSYS_DBUPDATEFILE)"
984        importSqlFile $OPENGNSYS_DBUSER $OPENGNSYS_DBPASSWORD $OPENGNSYS_DATABASE $OPENGNSYS_DBUPDATEFILE
985else
986        echoAndLog "Database unchanged."
987fi
988
989# Actualizar ficheros complementarios del servidor
990updateServerFiles
991if [ $? -ne 0 ]; then
992        errorAndLog "Error updating OpenGnsys Server files"
993        exit 1
994fi
995
996# Configurar Rsync.
997rsyncConfigure
998
999# Actualizar ficheros del cliente
1000updateClientFiles
1001updateInterfaceAdm
1002
1003# Actualizar páqinas web
1004apacheConfiguration
1005updateWebFiles
1006if [ $? -ne 0 ]; then
1007        errorAndLog "Error updating OpenGnsys Web Admin files"
1008        exit 1
1009fi
1010# Generar páginas Doxygen para instalar en el web
1011makeDoxygenFiles
1012
1013# Recompilar y actualizar los servicios del sistema
1014compileServices
1015
1016# Actaulizar ficheros auxiliares del cliente
1017updateClient
1018if [ $? -ne 0 ]; then
1019        errorAndLog "Error updating clients"
1020        exit 1
1021fi
1022
1023# Comprobar permisos y ficheros.
1024checkFiles
1025
1026# Mostrar resumen de actualización.
1027updateSummary
1028
1029#rm -rf $WORKDIR
1030echoAndLog "OpenGnsys update finished at $(date)"
1031
1032popd
1033
Note: See TracBrowser for help on using the repository browser.